| ## Public API Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- File List
- File Members

# csutil/typetraits.h File Reference

General type-traits classes used to do compile-time checking and operations on types. More...

Go to the source code of this file.

## Namespaces
namespace | CS
namespace | CS::TypeTraits
namespace | CS::TypeTraits::Implementation
## Classes
struct | CS::TypeTraits::IsReference< Type >
| Check if Type is a reference or simple type. More...
struct | CS::TypeTraits::Implementation::IsReferenceImpl< T >
struct | CS::TypeTraits::IsSame< Type1, Type2 >
| Check if two types are the same. More...
struct | CS::TypeTraits::Implementation::IsSameImpl< T, U >
struct | CS::TypeTraits::Implementation::NoType
| Boolean false type. More...
struct | CS::TypeTraits::Implementation::TraitAnd< b1, b2, b3, b4, b5, b6, b7 >
struct | CS::TypeTraits::Implementation::TraitAnd< true, true, true, true, true, true, true >
struct | CS::TypeTraits::Implementation::Wrap< T >
| Simple dummy-wrapper. More...
## Typedefs
typedef char | CS::TypeTraits::Implementation::YesType
| Boolean true type.
## Variables
T &(*)(Wrap< T >) | CS::TypeTraits::Implementation::IsReferenceHelper1 (Wrap< T >)

## Detailed Description

General type-traits classes used to do compile-time checking and operations on types.

Definition in file typetraits.h.